#define STRICT
#include <windows.h>
#if 0
extern "C" BOOL DropData(HWND hwnd, IDataObject *pDataObject);
extern "C" void RegisterDropWindow(HWND hwnd);
extern "C" void UnregisterDropWindow(HWND hwnd);

class CDataObject : public IDataObject
{
public:
	// IUnknown interface
	HRESULT __stdcall QueryInterface (REFIID iid, void ** ppvObject);
	ULONG	__stdcall AddRef (void);
	ULONG	__stdcall Release (void);

	// IDataObject interface
	HRESULT __stdcall GetData				(FORMATETC *pformatetcIn, STGMEDIUM *pmedium);
	HRESULT __stdcall GetDataHere			(FORMATETC *pformatetc, STGMEDIUM *pmedium);
	HRESULT __stdcall QueryGetData			(FORMATETC *pformatetc);
	HRESULT __stdcall GetCanonicalFormatEtc	(FORMATETC *pformatectIn, FORMATETC *pformatetcOut);
	HRESULT __stdcall SetData				(FORMATETC *pformatetc, STGMEDIUM *pmedium, BOOL fRelease);
	HRESULT __stdcall EnumFormatEtc			(DWORD dwDirection, IEnumFORMATETC **ppenumFormatEtc);
	HRESULT __stdcall DAdvise				(FORMATETC *pformatetc, DWORD advf, IAdviseSink *pAdvSink, DWORD *pdwConnection);
	HRESULT __stdcall DUnadvise				(DWORD dwConnection);
	HRESULT __stdcall EnumDAdvise			(IEnumSTATDATA **ppenumAdvise);
        
	// Constructor
	CDataObject();
	~CDataObject();

private:

	// Private member variables
	LONG	m_lRefCount;
	HWND	m_hWnd;

};

CDataObject::CDataObject() : m_lRefCount(0)
{

}

CDataObject::~CDataObject()
{

}

HRESULT __stdcall CDataObject::QueryInterface (REFIID iid, void ** ppvObject)
{
	// check to see what interface has been requested
	if(iid == IID_IDropTarget || iid == IID_IUnknown)
	{
		AddRef();
		*ppvObject = this;
		return S_OK;
	}
	else
	{
		*ppvObject = 0;
		return E_NOINTERFACE;
	}
}

ULONG __stdcall CDataObject::AddRef(void)
{
	return InterlockedIncrement(&m_lRefCount);
}	

ULONG __stdcall CDataObject::Release(void)
{
	LONG count = InterlockedDecrement(&m_lRefCount);

	if(count == 0)
	{
		delete this;
		return 0;
	}
	else
	{
		return count;
	}
}


//
//	IDataObject implementation
//
HRESULT __stdcall CDataObject::GetData(FORMATETC *pformatetcIn, STGMEDIUM *pmedium)
{
	return E_NOTIMPL;
}

HRESULT __stdcall CDataObject::GetDataHere(FORMATETC *pformatetc, STGMEDIUM *pmedium)
{
	return E_NOTIMPL;
}

//
//	Called to see if the data described by pFormatEtc is available
//
HRESULT __stdcall CDataObject::QueryGetData(FORMATETC *pFormatEtc)
{
	// A normal IDataObject will only support CONTENT renderings
	if(pFormatEtc->dwAspect != DVASPECT_CONTENT)
	{
		return DV_E_DVASPECT;
	}

	for(int i = 0; i < m_NumFormats; i++)
	{
		if(pFormatEtc->cfFormat == m_FormatEtc[i].cfFormat && 
		  (pFormatEtc->tymed & m_FormatEtc[i].tymed))
		{
			return S_OK;
		}
	}

	return DV_E_TYMED;
}

HRESULT __stdcall CDataObject::GetCanonicalFormatEtc(FORMATETC *pformatectIn, FORMATETC *pformatetcOut)
{
	return E_NOTIMPL;
}

HRESULT __stdcall CDataObject::SetData(FORMATETC *pformatetc, STGMEDIUM *pmedium, BOOL fRelease)
{
	return E_NOTIMPL;
}

HRESULT __stdcall CDataObject::EnumFormatEtc(DWORD dwDirection, IEnumFORMATETC **ppenumFormatEtc)
{
	return E_NOTIMPL;
}

HRESULT __stdcall CDataObject::DAdvise(FORMATETC *pformatetc, DWORD advf, IAdviseSink *pAdvSink, DWORD *pdwConnection)
{
	return OLE_E_ADVISENOTSUPPORTED;
}

HRESULT __stdcall CDataObject::DUnadvise(DWORD dwConnection)
{
	return OLE_E_ADVISENOTSUPPORTED;
}

HRESULT __stdcall CDataObject::EnumDAdvise(IEnumSTATDATA **ppenumAdvise)
{
	return OLE_E_ADVISENOTSUPPORTED;
}


int main(void)
{
	IDataObject *pDataObject;

	// Initialize COM and OLE
	if(OleInitialize(0) != S_OK)
		return 0;

	// Access the data on the clipboard
	if(OleGetClipboard(&pDataObject) == S_OK)
	{
		pDataObject->Release();
	}

	// Cleanup
	OleUninitialize();
	return 0;
}
#endif